package distraction;

import java.util.*;

import processing.core.*;
import rita.*;

import java.awt.event.*;
import java.net.HttpURLConnection;

// in which it is edited to be like Distraction4

// capture all the text in the area at one time, split it up

public class Distraction6 extends PApplet {

	private static final long serialVersionUID = -3822618250671142677L;

	// Text entry
	RiText entry;
	String entryContent, word, searchTerm;
	int lineCount, charCount;
	boolean cursorVisible;
	boolean shiftPressed;

	// Livejournal interface
	RiText postAnEntry;
	RiText subject;
	RiTextField subjectField;
	PImage logo;

	// Clouds
	ArrayList<ArrayList<String>> cloudText; 
	// Term, Site #, Sentence #
	// Just a 2D array for now
	// So, for each one just fill up the array list. 

	/**
	 * Setup
	 */
	public void setup() {
		size(1280,1024);

		// Livejournal interface
		RiText.createDefaultFont("arial rounded mt bold", 30);
		RiText.setDefaultColor(0, 48, 96);
		postAnEntry = new RiText(this, "Post an Entry", 25, 150);

		RiText.createDefaultFont("tahoma", 16);
		RiText.setDefaultColor(0);

		subject = new RiText(this, "Subject:", 25, 200);
		subjectField = new RiTextField(this, 90, 183, 735, 20, 18, "A stream of consciousness");

		logo = loadImage("lj.png");

		// Text entry
		RiText.createDefaultFont("courier", 16);
		entry = new RiText(this, 35, 250);
		entryContent = "";
		word = "";
		searchTerm = "";
		shiftPressed = false;

		// Clouds backend
		cloudText = new ArrayList<ArrayList<String>>();
		RiText.createDefaultFont("helvetica", 36);
		RiText.setDefaultColor(255);
		RiText.setDefaultBBoxFill(73, 196, 241, 200);
		RiText.setBoundingBoxStrokeWeights(0);
		RiText.setBoundingBoxesVisible(true);
		
		// Timer
		new RiTimer(this, .5f);
		cursorVisible = false;
	}

	/**
	 * times the cursor
	 * @param re
	 */
	public void onRiTaEvent(RiTaEvent re) { 
		if (cursorVisible == false) {
			entry.setText(entryContent + "|");
			cursorVisible = true;
		} else {
			entry.setText(entryContent);
			cursorVisible = false;
		}
	}

	/**
	 * Text entry
	 */
	public void keyPressed() {

		if ((key>='A' && key <= 'z') || (key>='0' && key <= '9') || key == ' ' || key == '-' || key == ';' ||
				key == '=' || key == '[' || key == ']' || key == ',' || key == '.' || key == '/' || key == '\n' || 
				key == '\'') {

			// ? !
			if (shiftPressed == true && (key == '/' || key == '1' || key == ';')) {

				Thread t = new Thread() {
					public void run() {
						println("[SEARCH] " + searchTerm);
						search(searchTerm);
						searchTerm = "";
					}
				};
				t.start();

				if (key == '/') {
					entryContent += "?";
					word += "?";
				} else if (key == '1') {
					entryContent += "!";
					word += "!";
				} else if (key == ';') {
					entryContent += ":";
					word += ":";
				} else if (key == '\'') {
					entryContent += "\"";
					word += "\"";
				}
			} else if (key == '\n') {
				entryContent += key;
			} else {
				entryContent += key; // add key to content
				searchTerm += key;
			}

			shiftPressed = false;

			entry.setText(entryContent);
			charCount++;

			if (key == ' ') {

				// TODO: if word is and, query the search term
				/*	if (word == "and") {
					println("true");
					searchTerm = searchTerm.substring(0, searchTerm.length() - 4);
					Thread t = new Thread() {
						public void run() {
							println("[SEARCH] " + searchTerm);
							search(searchTerm);
							searchTerm = "";
						}
					};
					t.start();
				} */

				word = "";
			} else {
				word += key;
			}

			// backspacing
		} else if (key == '\b') {

			try {
				entryContent = entryContent.substring(0, entryContent.length() - 1);
				entry.setText(entryContent);
				charCount--;

				// if it goes back a line
				if (entryContent.endsWith("\n")) {
					charCount = 73;
				}
			} catch (StringIndexOutOfBoundsException e1) {
				return;
			}

			try {
				word = word.substring(0, word.length() - 1);
			} catch (StringIndexOutOfBoundsException e1) {
				word = "";
			}

			try {
				searchTerm = searchTerm.substring(0, searchTerm.length() - 1);
			} catch (StringIndexOutOfBoundsException e1) {
				searchTerm = "";
			}

		} else if (key == '\n') {

			Thread t = new Thread() {
				public void run() {
					println("[SEARCH] " + searchTerm);
					search(searchTerm);
					searchTerm = "";
				}
			};
			t.start();

			lineCount++;
		}

		else if (keyCode == SHIFT) {
			shiftPressed = true;
		}

		// new line
		if (charCount == 75) { 

			if (word.length() < 75) {
				entryContent = entryContent.substring(0, entryContent.length() - word.length());
				entryContent += '\n' + word;
			}
			else {
				entryContent += '\n';
			}

			charCount = 0;
			lineCount++;
		}

		// Delimiting, getting search terms
		if (searchTerm != "" && (key == '.' || key == ',')) {	//  || word == "and"
			searchTerm = searchTerm.substring(0, searchTerm.length() - 1);

			Thread t = new Thread() {
				public void run() {
					println("[SEARCH] " + searchTerm);
					search(searchTerm);
					searchTerm = "";
				}
			};
			t.start();
		}
	}

	/** 
	 * Search the term in Google and return results on console
	 * @param term
	 */
	public void search(String term) {

		RiHtmlParser fetcher = new RiHtmlParser(this);
		term = term.replace(' ', '+'); 	// convert the term's spaces to pluses

		String url = "http://www.google.com/search?q=\"" + term + "\"";

		// String pageContent = "";

		// pageContent = fetcher.fetch(url, true);
		String[] titleArray = fetcher.fetchLinkText(url);

		// println(url);
		// println(titles.length);
		ArrayList<String> titleArrayList = new ArrayList<String>();

		for (int i = 11; i < titleArray.length - 5; i++) {
			if (!titleArray[i].contains("Cached") && 
					!titleArray[i].contains("Similar pages") &&
					(titleArray[i].length() > 2)) {
				println(titleArray[i]);
				titleArrayList.add(titleArray[i]);
			}
		}
		
		int start = 0;
		int x = 0;
		int y = 0;
		RiText cloud;
		// Start displaying them one by one, according to a timer - millis()
		if (millis() - start > 400){
			start = millis();
		
		  cloud = new RiText(this, "Claire Kwong", x, y);
			
		}

		// Start filling up the array list
		// new entry in the first array list
		// Should involve a list of links as well, but do that later
		// currently just a list of titles

		// cloudText.add(titleArrayList);
		
	}

	/**
	 * Draw
	 */
	public void draw() {
		background(255);

		// Create visual layout
		strokeWeight(0);

		// title bar
		stroke(96,152,200);
		fill(96,152,200);
		rect(0,0,width,60);

		// menu bar
		stroke(255);
		fill(0, 48, 96);
		rect(-1,60,width+1,20);

		// third bar
		stroke(96,152,200);
		fill(96,152,200);
		rect(0,81,width,20);

		image(logo,0,0);

		// entry box
		stroke(0);
		fill(255);
		rect(25, 225, 800, 500);

		// display clouds -- but somewhere else, on event, not in draw...
		/*	  if (!cloudText.isEmpty()) {

			  // Start threads for every site, to start displaying? Well, actually, 
			  for (int i = 0; i < cloudText.size(); i++) {

			  }

		  }	*/

		// testing

		/*	  RiText.createDefaultFont("helvetica", 36);
			RiText.setDefaultColor(255);
			RiText.setDefaultBBoxFill(73, 196, 241, 200);
			RiText.setBoundingBoxStrokeWeights(0);
			RiText.setBoundingBoxesVisible(true);

			int x = 300;
			int y = 200;
		  RiText cloud = new RiText(this, "Claire Kwong", x, y);
		  if (mouseX > x && mouseX < x+cloud.textWidth() && mouseY > y-cloud.textHeight() && mouseY < y) {
			  println("true");
		  } else println("false");	*/
	}
}
